// ########################################################################
// ## anzahltabelle.h:                                                   ##
// ## Klasse zur Verwaltung der Anzahltabelle fr RandCubic              ##
// ## Copyright Thomas Dreibholz, uzs6pq@ibm.rhrz.uni-bonn.de            ##
// ##           WWW Homepage:     http://ibm.rhrz.uni-bonn.de/~uzs6pq    ##
// ########################################################################

#ifndef ANZAHLTABELLE_H
#define ANZAHLTABELLE_H


#include "../system.h"


#if #AnzahlAuswahl(i32)
#define AnzahlTyp            card32
#define AnzahlTypName        "card32"
#define AnzahlTabelleGroesse 11
#endif
#if #AnzahlAuswahl(i64)
#define AnzahlTyp            card64
#define AnzahlTypName        "card64"
#define AnzahlTabelleGroesse 18
#endif
#if #AnzahlAuswahl(d64)
#define AnzahlTyp            double
#define AnzahlTypName        "double"
#define AnzahlTabelleGroesse 120
#endif
#if #AnzahlAuswahl(d96)
#define AnzahlTyp            long double
#define AnzahlTypName        "long double"
#define AnzahlTabelleGroesse 1240
#endif

// Klasse zur Verwaltung der Anzahltabelle
class Anzahltabelle
{
   public:
   // Konstruktor und Destruktor
   Anzahltabelle();
   ~Anzahltabelle();

   // Abfrage der Anzahl der Eintrge und tabelleneintrge
   inline const card32 Eintraege();
   inline const AnzahlTyp A(const long n);
   inline const AnzahlTyp B(const long n);
   inline const AnzahlTyp C(const long n);
   inline const AnzahlTyp D(const long n);
   
   friend ostream& operator<<(ostream& os, const Anzahltabelle& tabelle);

   private:
   card32  eintraege;
   AnzahlTyp* speicher;
   AnzahlTyp* tabelleA;
   AnzahlTyp* tabelleB;
   AnzahlTyp* tabelleC;
   AnzahlTyp* tabelleD;
};

extern Anzahltabelle tabelle;

#endif
