// ########################################################################
// ## ausgabe.cc                                                         ##
// ## Textausgabe fr Graphen-Dateien im TDGF-Format                     ##
// ## Copyright Thomas Dreibholz, uzs6pq@ibm.rhrz.uni-bonn.de            ##
// ##           WWW Homepage:     http://ibm.rhrz.uni-bonn.de/~uzs6pq    ##
// ########################################################################

#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>

#include "tdgf.h"
#include "graph.h"
#include "graph.icc"


// Hauptprogramm
int32 main(int32 argc, char** argv)
{
   if(argc != 2) {
      cerr << "Aufruf: " << argv[0] << " [TDGF-Datei]" << endl;
      exit(1);
   }
  
   ifstream    is;
   TDGF_Header tdgf;
   INFO_Header info;
   char        str[128];
   card32      zaehler = 1;

   switch(OeffneTDGF(is,argv[1],&tdgf,&info)) {
      case dos:
          cerr << "Fehler beim Lesen der Datei!" << endl;
          exit(1);
       break;
      case format:
          cerr << "Diese Datei hat kein TDGF-Format!" << endl;
          exit(1);
       break;
      case byteOrder:
          cerr << "Diese Datei hat eine inkompatible Byte-Order!" << endl;
          exit(1);
       break;
      default:
       break;
   }

   cout << "Titel:         " << info.Titel     << endl;
   cout << "Copyright:     " << info.Copyright << endl;
   cout << "Erstellt mit:  " << info.Programm  << endl;
   sprintf(str,"%02d.%02d.%04d  %2d:%02d:%02d %s",
           info.Tag,info.Monat,info.Jahr,
           info.Stunde,info.Minute,info.Sekunde,info.Zone);
   cout << "Datum/Uhrzeit: " << str << endl << endl;

   Graph graph;
   while(graph.Lese(is)) {
      cout << "#" << zaehler++ << ":" << endl << graph << endl;
   }

   return 0;
}
